//-----------------------------------------------------------------------------
//
// FMRXrds.h
//
// Contains the function prototypes for the functions contained in FMRXrds.c
//
//-----------------------------------------------------------------------------
#ifndef _FMRXRDS_H_
#define _FMRXRDS_H_
// #include "typedefs.h"

//-----------------------------------------------------------------------------
// Defines
//-----------------------------------------------------------------------------
//#define MSG_COUNT 1
#define MSG_LENGTH 1
//#define MSG_ROWS 1

//-----------------------------------------------------------------------------
// Function prototypes
//-----------------------------------------------------------------------------
extern void updateRds(void);
extern void initRdsVars(void);
extern void si47_rdsGetBler(int *bler);

#endif

//-----------------------------------------------------------------------------
// Globals
//-----------------------------------------------------------------------------
bool RdsFifoEmpty;

// Determines if the basic or advanced PS/RT RDS display functions are used
// The basic functions are closely tied to the recommendations in the RBDS
// specification and are faster to update but more error prone. The advanced
// functions attempt to detect errors and only display complete messages

// RDS Program Identifier
//int piDisplay;              // Displayed Program Identifier //xdata 

// RDS Program Type
//char ptyDisplay;             // Displayed Program Type //xdata 

bool firstInitDone = 0;
char rdsBlerMax[4]; //xdata 

// RDS flags and counters  // alle in xdata
       char  RdsDataAvailable = 0;  // Count of unprocessed RDS Groups
static char  RdsIndicator     = 0;  // If true, RDS was recently detected
static int RdsDataLost      = 0;  // Number of Groups lost
static int RdsBlocksValid   = 0;  // Number of valid blocks received
static int RdsBlocksTotal   = 0;  // Total number of blocks expected
static int RdsBlockTimer    = 0;  // Total number of blocks expected
static int RdsGroups      = 0;    //xdata 
static int RdsValid[4];           //xdata 

//----------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------    
// This variables are used by the status commands.  Make sure to call those
// commands (fmRsqStatus, fmTuneStatus, or fmRdsStatus) prior to access.
extern char   Status;  //xdata
extern char   RsqInts;  //...
extern char   STC;
extern char   SMUTE;
extern char   BLTF;
extern char   AFCRL;
extern char   Valid;
extern char   Pilot;
extern char   Blend; //xdata
extern int 	  Freq;
extern char   RSSI;
extern char   ASNR;
extern int	  AntCap;
extern char   FreqOff;
char   RdsInts;
char   RdsSync;
char   GrpLost;
char   RdsFifoUsed;
int  BlockA;
int  BlockB;
int  BlockC;
int  BlockD;
char   BleA;
char   BleB;
char   BleC;
char   BleD;

//-----------------------------------------------------------------------------
// local defines
//-----------------------------------------------------------------------------
#define RDS_TYPE_0A     ( 0 * 2 + 0)	//0
#define RDS_TYPE_0B     ( 0 * 2 + 1)	//1
#define RDS_TYPE_1A     ( 1 * 2 + 0)
#define RDS_TYPE_1B     ( 1 * 2 + 1)
#define RDS_TYPE_2A     ( 2 * 2 + 0)	//4
#define RDS_TYPE_2B     ( 2 * 2 + 1)	//5
#define RDS_TYPE_3A     ( 3 * 2 + 0)	//6
#define RDS_TYPE_3B     ( 3 * 2 + 1)
#define RDS_TYPE_4A     ( 4 * 2 + 0)	//8
#define RDS_TYPE_4B     ( 4 * 2 + 1)
#define RDS_TYPE_5A     ( 5 * 2 + 0)
#define RDS_TYPE_5B     ( 5 * 2 + 1)
#define RDS_TYPE_6A     ( 6 * 2 + 0)
#define RDS_TYPE_6B     ( 6 * 2 + 1)
#define RDS_TYPE_7A     ( 7 * 2 + 0)
#define RDS_TYPE_7B     ( 7 * 2 + 1)
#define RDS_TYPE_8A     ( 8 * 2 + 0)
#define RDS_TYPE_8B     ( 8 * 2 + 1)
#define RDS_TYPE_9A     ( 9 * 2 + 0)
#define RDS_TYPE_9B     ( 9 * 2 + 1)
#define RDS_TYPE_10A    (10 * 2 + 0)
#define RDS_TYPE_10B    (10 * 2 + 1)
#define RDS_TYPE_11A    (11 * 2 + 0)
#define RDS_TYPE_11B    (11 * 2 + 1)
#define RDS_TYPE_12A    (12 * 2 + 0)	//24
#define RDS_TYPE_12B    (12 * 2 + 1)	//25
#define RDS_TYPE_13A    (13 * 2 + 0)
#define RDS_TYPE_13B    (13 * 2 + 1)
#define RDS_TYPE_14A    (14 * 2 + 0)
#define RDS_TYPE_14B    (14 * 2 + 1)
#define RDS_TYPE_15A    (15 * 2 + 0)
#define RDS_TYPE_15B    (15 * 2 + 1)
//bpark
#define RDS_TYPE_124A    (124 * 2 + 0)	//248

#define CORRECTED_NONE          0
#define CORRECTED_ONE_TO_TWO    1
#define CORRECTED_THREE_TO_FIVE 2
#define UNCORRECTABLE           3
#define ERRORS_CORRECTED(data,block) ((data>>block)&0x03)

#define BLER_SCALE_MAX 200  // Block Errors are reported in .5% increments
//#define RT_VALIDATE_LIMIT 2
//bpark
#define PCH_VALIDATE_LIMIT 2	//2
