//*******************************************************************************
//Hardware Functions SPI fr DOG-EA LCD
//MSP430G2231 Launchpad
//*******************************************************************************
#include "typedefs.h"
#include "in430.h"
#include  <msp430g2231.h>
#include "hardware.h"

//**************** Funktionsprototypen *****************************************
void Clock_L();
void Clock_H();
void DataOut(char Data);
void Reset_H();
void CS_H();
void CS_L();
void SCL_Clock(void);
void CommandMode();		//Commando aktiv L
void DataMode();				//Daten Mode H

//*******************************************************************************
void DataOut(char Data)
{//Ein Byte serialisieren left -> right
	
u8 i;
u8 j;
  
  for (i=8; i>0; i--)
  {
    Clock_L();
    
    j = (Data&(1<<(i-1)));
    
    if (j)		//(((Data[i]) 
    	P1OUT |= data;	//BIT0;			//SDA_high(); 
    else P1OUT &= ~data;	//BIT0;		//SDA_low();
    
    Clock_H();	//SCL_Clock();  //H->L
  }
  
}
	
//*******************************************************************************
void DataOutRL(char Data)
{//Ein Byte serialisieren right -> left
	
	u8 i;
	char d;
	
	d = Data;
	
	for (i=8; i>0; i--)
  { 
    Clock_L();
     
    if (d & 0x01)		//(((Data[i]) 
    	P1OUT |= data; //BIT0;				//SDA_high(); 
    else 
    	P1OUT &= ~data;	//BIT0;		//SDA_low();
    
    d = d >> 1;
    
    Clock_H();
  }
}

void Reset_LH()
{	
	P1DIR |= reset;
	P1OUT &= ~reset;	//BIT3;
	wait_us(50);
	P1OUT |= reset;		//BIT3;

}

void Clock_H()
{	
	P1DIR |= clk;
	P1OUT |= clk;	//BIT1;
}

void Clock_L()
{	
	P1DIR |= clk;
	P1OUT &= ~clk;
}

void CS_L()	
{	//Lcd_Select()
	P1DIR |= cs;
	P1OUT &= ~cs;
}

void CS_H()
{	
	P1DIR |= cs;
	P1OUT |= cs;
}

void CommandMode()		//Commando aktiv L
{	
	P1OUT &= ~BIT2;
}

void DataMode()				//Daten Mode H
{	
	P1OUT |= BIT2;
}

void SCL_Clock(void)
{
  Clock_H();
  Clock_L();
}
