#ifndef HARDWARE_H
#define HARDWARE_H

#include <signal.h>

//Port Output Register 'P1OUT, P2OUT':
#define P3OUT_INIT      0x0A     // Init Output data of port3
                                 // P3.1 auf H
                                 // P3.3 auf H

//Port Direction Register 'P1DIR, P2DIR':
#define P3DIR_INIT      0xff     // Init of Port3 Data-Direction Reg (Out=1 / Inp=0)
                                 // P3.1: In-/Output SDA
                                 // P3.3: Output SCL

//Selection of Port or Module -Function on the Pins 'P1SEL, P2SEL'
#define P3SEL_INIT      0        // P3-Modules:

//Interrupt capabilities of P1 and P2

#define WDTCTL_INIT     WDTPW|WDTHOLD

//#define OV7141 0x21     /* I2C address of OV7141 chips, shifted once >> */
#define SCLL 0x07    //CLOCK LOW  P3.3  // ((1<<3))     /* Pin 3.3 */
#define SCLH 0x08    //CLOCK HIGH
#define SDAL 0x0B    //Data LOW P3.2    // ((1<<1))     /* Pin 3.1 */
#define SDAH 0x04    //Data HIGH
#define IICO P3OUT
#define IICI P3IN
#define IICD P3DIR

//Defines
//PCH  Port1
#define clk BIT5
#define data BIT4
#define reset BIT6	//BIT6
#define cs BIT7	//BIT7
#define led BIT0	//Port1

#endif //HARDWARE_H
