#define ONE_MHz			0
#define EIGHT_MHz		1
#define TWELVE_MHz		2
#define SIXTEEN_MHz		3
#define CLOCK			TWELVE_MHz //ONE_MHz	//SIXTEEN_MHz	//TWELVE_MHz

#include "in430.h"
#include "i2c.h"
#include "470x.h"
#include <msp430f2274.h>
#include "flash.h"

int main(void)
{

  	// Stop watchdog timer to prevent time out reset
    WDTCTL = WDTPW + WDTHOLD;
    
//  DCO Calibration Data (provided from factory in flash info memory segment A)
//	DCO Frequency Calibration Register Size Address
//	1 MHz 
//	CALBC1_1MHZ byte 010FFh
//	CALDCO_1MHZ byte 010FEh
//	8 MHz 
//	CALBC1_8MHZ byte 010FDh
//	CALDCO_8MHZ byte 010FCh
//	12 MHz 
//	CALBC1_12MHZ byte 010FBh
//	CALDCO_12MHZ byte 010FAh
//	16 MHz 
//	CALBC1_16MHZ byte 010F9h
//	CALDCO_16MHZ byte 010F8h

    //Takt einstellen auf ca. 5MHz
//	DCOCTL = DCO0 + DCO1 + DCO2;
//	BCSCTL1 = RSEL0 + RSEL1 + RSEL2;
//	BCSCTL2 = SELM_0 + DIVM_0 + DIVS_0;
    
	switch(CLOCK)
	{
		case ONE_MHz:
			BCSCTL1 = CALBC1_1MHZ; // Set DCO to xxMHz
			DCOCTL = CALDCO_1MHZ;
			break;
		
		case EIGHT_MHz:	
			BCSCTL1 = CALBC1_8MHZ; // Set DCO to xxMHz
			DCOCTL = CALDCO_8MHZ;
			break;
			
		case TWELVE_MHz:	
			BCSCTL1 = CALBC1_12MHZ; // Set DCO to xxMHz
			DCOCTL = CALDCO_12MHZ;
			break;
			
		case SIXTEEN_MHz:	
			BCSCTL1 = CALBC1_16MHZ; // Set DCO to xxMHz
			DCOCTL = CALDCO_16MHZ;
			break;
	}
	
    P1DIR |= 0xFF;  
    P1OUT &= 0xFE;  //LED aus
    P1OUT |= 0x01;  //LED an
    //LED(0);
    
    P3SEL &= 0x00;          //P3SEL_INIT;     //Select port or module -function on port3
    P3REN |= 0x0C;          //3.2 3.3
    P3DIR |= 0x0C;          //P3DIR_INIT;     //Init port direction register of port3
    
    //P4 fr Flash
    //Ausgnge
    P4DIR |= SCL_F;
    P4DIR |= WP_F;
    P4DIR |= CS_F;
    P4DIR |= SI_F;
    //Eingang
    P4DIR &= ~SO_F;
	
	si47xxFMRX_initialize();  //reset + Power_up
				
	test_FMRXrds();
	
	lcd_initial();
  	lcd_test();
}

void wait_ms(int ms)
{
    int i;

    for ( i = 0; i < ms; i++ ) 
    {
        wait_us(1000);
    }
}

void wait_us(int us)
{
	long j;
    long i;
    double f;
    
    switch (CLOCK)
    {
    	case ONE_MHz:
    		f=0.048;
    		break;
    	
    	case EIGHT_MHz:
    		f=0.048 * 8;
    		break;
    	
    	case TWELVE_MHz:
    		f=0.048 * 12;
    		break;
    		
    	case SIXTEEN_MHz:
    		f=0.048 * 16;
    		break;
    }
    
    j = us * f;
    
    for (i=0;i<=j;i++)
    {
    	//wait_ns(1000);
    }
}
